



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>css高度自适应</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">css高度自适应</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 09:34:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>何为高度自适应？</strong></p>
<p>高度自适应就是高度能跟随浏览器窗口的大小改变而改变，典型的运用在一些后台界面中上面一栏高度固定用作菜单栏或导航栏，下面一栏高度自适应用于显示内容。高度自适应不像宽度自适应那样简单，在兼容浏览器方面也稍微复杂一些。</p>
<p><strong>布局思路</strong></p>
<p>在IE7+及chrome、firefox等浏览器中，高度自适应可以利用绝对定位来解决。但一个元素是绝对定位时，如果没有给它设定高度或宽度，则它的的高度和宽度是由它的top、right、bottom、left属性决定的，但这一法则在IE6中并不适用，因此在IE6中还得另辟蹊径。在IE6中给html设定padding,并不会撑大html元素的尺寸，这正是我们要利用的地方。</p>
<p>下面的这段代码没管Ie，在chrome下显示正常：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">&lt;style&gt;<br />
body,div{<br />
    margin:0;<br />
    padding:0;<br />
    color:#f00;<br />
}<br />
.top{<br />
    background:#36c;<br />
    height:100px;<br />
}<br />
.main{<br />
    background:#f90;<br />
    width:100%;<br />
    position:absolute;<br />
    top:100px;<br />
    bottom:0;<br />
}<br />
&lt;/style&gt;<br />
&lt;/head&gt;

&lt;body&gt;<br />
&lt;div class="top"&gt;wo shi top&lt;/div&gt;<br />
&lt;div class="main"&gt;wo shi main&lt;/div&gt;<br />
&lt;/body&gt;</pre>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1031874/201701/1031874-20170104101439112-1406318293.png" /></p>
<p>如果把position:absolute注释掉。则显示：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1031874/201701/1031874-20170104101510472-1811516023.png" /></p>
<p>可以看到main只根据内容占了一行。</p>
<p><strong>推广</strong></p>
<p>这种方法也适用于顶栏与底栏高度固定，中间那栏高度自适应的三栏布局.</p>
<p>如果我们把position改成relative，则显示如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1031874/201701/1031874-20170104101549753-550185363.png" /></p>
<p>relative，设置top，left只是相对于原来的文字偏移而已</p>
<pre class="prettyprint linenums"></pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7n3dg9.html">C&mdash;&mdash;没有bool的C语言？</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnygk28.html">MySQL初探</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwz7mrq.html">与TCP&sol;IP协议的初次见面（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zwpwv8.html">css3整理--filter</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydwg3gq.html">、web前端的这么知识应该是怎样的一个知识体系架构？</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xpxj68.html">Dotfuscator可以实现混淆代码、变量名修改、字符串加密</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdnynl8.html">jquery获得option的值&lpar;示例&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj71y49.html">flash链接需要后台调用时的插入flash方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1djej9.html">Jordan Lecture Note-4&colon; Linear &amp;amp&semi; Ridge Regression</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjlvv79.html">IE查看控件时常</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey166j9.html">Linux下的softlink和hardlink（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zeo5x9.html">iOS设置UITableView中Cell被默认选中后怎么触发didselect事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk4m4v8.html">flask连接sqlalchemy数据库&comma;实现简单的登录跳转功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdplml7q.html">BZOJ 2957&colon; 楼房重建 &lbrack;线段树 信息合并&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljz3j19.html">jquery  on&lpar;&rpar;方法重复绑定解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7omnne8.html">安装Feflow遇取的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjxpkl9.html">【微收藏】FourShadows&period;js &ndash; 时间感知的算法驱动的图标阴影JS库</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjked79.html">在模拟器上运行Android项目时报错：DELETE&lowbar;FAILED&lowbar;INTERNAL&lowbar;ERROR Error while Installing APKs</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1r26g9.html">python读取Excel文件。</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw1k5z8.html">markdown简单入门</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/2q7d3lgq.html">http&colon;&sol;&sol;www&period;360doc&period;com&sol;content&sol;13&sol;0516&sol;22&sol;12094763&lowbar;285956121&period;shtml</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwwedkq.html">C&num; 串口操作系列&lpar;3&rpar; -- 协议篇，二进制协议数据解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k2lr58.html">IOS--UIAlertView造成屏幕闪烁</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8oywx1q.html">laravel框架学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k2zd58.html">nginx的初步了解</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q23lwl9.html">抢凳子日数据sql</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q23lp39.html">I&sol;O流&mdash;&mdash;字符流</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r7rod8.html">machine learning-----&amp;gt&semi;Amazon Machine Learning机器学习平台</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8oy655q.html">【Android端 APP GPU过度绘制】GPU过度绘制及优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/r9374gn8.html">极光推送NotificationServiceTest&period;appex文件变红不存在丢失解决办法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
